from .download import download_zip, download_file
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "data.zip",down_path)

bl_info = {
    "name": "Aqua Addon",
    "description": "Addon for creating underwater scenes in Blender",
    "author": "Raisy Clutch",
    "version": (1, 0, 0),
    "blender": (2, 90, 0),
    "location": "3D View > Tools > Aqua Addon",
    "warning": "", 
    "wiki_url": "https://blendermarket.com/products/aqua-addon",
    "tracker_url": "",
    "category": "Object"
}

import os
import bpy
import webbrowser

from bpy.props import (StringProperty,
                       BoolProperty,
                       IntProperty,
                       FloatProperty,
                       EnumProperty,
                       PointerProperty,
                       FloatVectorProperty
                       )
from bpy.types import (Modifier, Panel,
                       Operator,
                       PropertyGroup,
                       )

path = os.path.dirname(__file__) + "/data/data.blend\\Collection\\"
obb = os.path.dirname(__file__) + "/data/data.blend\\Object\\"
wm = bpy.context.window_manager


def append(typer, obj, filer):
    file_path = os.path.dirname(__file__) + "/data/" + filer + ".blend"
    inner_path = typer
    object_name = obj
 
    bpy.ops.wm.append(
        filepath=os.path.join(file_path, inner_path, object_name),
        directory=os.path.join(file_path, inner_path),
        filename=object_name
        )

def hid(obj, state):
    if bpy.data.objects.find(obj) > -1:
        bpy.data.objects[obj].hide_viewport = state
        bpy.data.objects[obj].hide_render = state

def adcc(obj, blend):
    if bpy.data.collections.find(obj) == -1:
        path = os.path.dirname(__file__) + "/data/"+ blend +".blend\\Collection\\"
        bpy.ops.wm.append(filename=obj, directory=path)
    else:
        donatin = "yah"

def ado(obj, blend):
    path = os.path.dirname(__file__) + "/data/"+ blend +".blend\\Object\\"
    if bpy.data.object.find(obj) == -1:
        bpy.ops.wm.append(filename=obj, directory=path)
    else:
        print(" INFO: Exists")

def adw(obj, blend):
    path = os.path.dirname(__file__) + "/data/"+ blend +".blend\\World\\"
    if bpy.data.worlds.find(obj) == -1:
        append("World", obj, blend)
        bpy.context.scene.world = bpy.data.worlds["AQUA WORLD"]
    else:
        print(" INFO: Exists")

def adoo(obj, blend):
    path = os.path.dirname(__file__) + "/data/"+ blend +".blend\\Object\\"
    bpy.ops.wm.append(filename=obj, directory=path)

    
def delx(objZ):
    if bpy.data.collections.find(objZ) > 0:
        collection = bpy.data.collections.get(objZ)
        for obj in collection.objects:
            bpy.data.objects.remove(obj, do_unlink=True)
        bpy.data.collections.remove(collection)
    
def addx(obj):
    path = os.path.dirname(__file__) + "/data/data.blend\\Collection\\"
    if bpy.data.collections.find(obj) == -1:
        append("Collection", obj, "data")
    else:
        print("AVIATION INFO: plane exists")

def adx(obj):
    path = os.path.dirname(__file__) + "/data/data.blend\\Collection\\"
    if bpy.data.collections.find(obj) == -1:
        bpy.ops.wm.append(filename=obj, directory=path)
    else:
        do_nothing = True

def odx(obj):
    path = os.path.dirname(__file__) + "/data/data.blend\\Object\\"
    if bpy.data.objects.find(obj) == -1:
        bpy.ops.wm.append(filename=obj, directory=path)
        bpy.context.view_layer.objects.active = bpy.data.objects[obj]
    else:
        do_nothing = True


def clrmod(self, context):
    wm = context.window_manager
    scene = context.scene
    obj = bpy.context.active_object
    
    try:
        for mods in obj.modifiers:
            obj.modifiers.remove(mods)

    except:
        print("Error")
        self.report({'ERROR'}, 'Oops, Make Sure you have selected an object')

class WM_OT_aquareveal(bpy.types.Operator):
    """Clear Generated Aqua"""
    bl_label = "Clear Camera"
    bl_idname = "aqua.clr"

    def execute(self, context):
        scene = context.scene
        obj = bpy.context.active_object
        wm = context.window_manager
        collection = bpy.data.collections.get('Aqua Under Water')
 
        for obj in collection.objects:
           bpy.data.objects.remove(obj, do_unlink=True)
    
        bpy.data.collections.remove(collection)

        return {'FINISHED'}



class WM_OT_infoist(bpy.types.Operator):
    """Open Youtube Channel to subscribe"""
    bl_label = "subscribe"
    bl_idname = "aqua.addinfo"

    def execute(self, context):
        scene = context.scene
        obj = bpy.context.active_object
        wm = context.window_manager
        webbrowser.open("https://youtube.com/channel/UCTDPlQiLXGMzgL4JfvKdSSQ")
        
        return {'FINISHED'}

class WM_OT_infosst(bpy.types.Operator):
    """Open Discord"""
    bl_label = "subscribe"
    bl_idname = "aqua.addinfoz"

    def execute(self, context):
        scene = context.scene
        obj = bpy.context.active_object
        wm = context.window_manager
        webbrowser.open("https://discord.gg/R9XNyyXtjs")
        
        return {'FINISHED'}


class WM_OT_aquaasset(bpy.types.Operator):
    """Generate Aqua"""
    bl_label = "Add Asset"
    bl_idname = "aqua.addasset"

    def execute(self, context):
        scene = context.scene
        obj = bpy.context.active_object
        wm = context.window_manager
        bpy.context.scene.eevee.use_bloom = True
        addx("Aqua Under Water")
        adw("AQUA WORLD", "data")
 

        return {'FINISHED'}

class WM_OT_aquacombo(bpy.types.Operator):
    """Add model to scene"""
    bl_label = "Add Element"
    bl_idname = "aqua.addcombo"

    def execute(self, context):
        scene = context.scene
        obj = bpy.context.active_object
        wm = context.window_manager

        return {'FINISHED'}

def enum_previews_from_directory_itemsa(self, context):
    """EnumProperty callback"""
    enum_items = []

    if context is None:
        return enum_items

    wm = context.window_manager
    directory = os.path.join(os.path.dirname(__file__), "thumbs/assets")

    aquallea = preview_collections["maainea"]

    if directory == aquallea.sh_previews_direa:
        return aquallea.sh_previewsea

    print("Scanning directory: %s" % directory)

    if directory and os.path.exists(directory):
        image_paths = []
        for fn in os.listdir(directory):
            if fn.lower().endswith(".png"):
                image_paths.append(fn)

        for i, name in enumerate(image_paths):
            filepath = os.path.join(directory, name)
            thumb = aquallea.load(filepath, filepath, 'IMAGE')
            enum_items.append((name, name, "Element", thumb.icon_id, i))

    aquallea.sh_previewsea = enum_items
    aquallea.sh_previews_direa = directory
    return aquallea.sh_previewsea


def enum_previews_from_directory_itemsj(self, context):
    """EnumProperty callback"""
    enum_items = []

    if context is None:
        return enum_items

    wm = context.window_manager
    directory = os.path.join(os.path.dirname(__file__), "thumbs/aqua")

    aqualle = preview_collections["maaine"]

    if directory == aqualle.sh_previews_dire:
        return aqualle.sh_previewse

    print("Scanning directory: %s" % directory)

    if directory and os.path.exists(directory):
        image_paths = []
        for fn in os.listdir(directory):
            image_paths.append(fn)

        for i, name in enumerate(image_paths):
            filepath = os.path.join(directory, name)
            thumb = aqualle.load(filepath, filepath, 'IMAGE')
            enum_items.append((name, name, "Element", thumb.icon_id, i))

    aqualle.sh_previewse = enum_items
    aqualle.sh_previews_dire = directory
    return aqualle.sh_previewse

def enum_previews_from_directory_ite(self, context):
    """EnumProperty callback"""
    enum_items = []

    if context is None:
        return enum_items

    wm = context.window_manager
    directory = os.path.join(os.path.dirname(__file__), "thumbs")

    aqual = preview_collections["maine"]

    if directory == aqual.sh_previews_di:
        return aqual.sh_previe

    print("Scanning directory: %s" % directory)

    if directory and os.path.exists(directory):
        image_paths = []
        for fn in os.listdir(directory):
            if fn.lower().endswith(".png"):
                image_paths.append(fn)

        for i, name in enumerate(image_paths):
            filepath = os.path.join(directory, name)
            thumb = aqual.load(filepath, filepath, 'IMAGE')
            enum_items.append((name, name, "Element", thumb.icon_id, i))

    aqual.sh_previe = enum_items
    aqual.sh_previews_di = directory
    return aqual.sh_previe

class OBJECT_PT_aquaPanel(Panel):
    bl_label = "Aqua"
    bl_idname = "OBJECT_PT_aqua_panel"
    bl_space_type = "VIEW_3D"   
    bl_region_type = "UI"    
    bl_category = "Aqua"
    bl_context = "objectmode"   

    def draw(self, context):
        layout = self.layout
        layout.scale_y = 1.5
        wm = context.window_manager
        scene = context.scene
        layout.operator("aqua.addasset", icon="MOD_FLUIDSIM", text='Generate Aqua')
        layout.operator("aqua.clr", text='Clear Aqua')
        layout.separator()

        if bpy.data.collections.find("Aqua Under Water") > -1:
            box = layout.box()
            box.label(text="Ocean Material", icon="MOD_FLUID")
            box.prop(bpy.data.materials["AQUA OCEAN"].node_tree.nodes["Refraction BSDF"].inputs[0],'default_value',text="Color")
            box.prop(bpy.data.materials["AQUA OCEAN"].node_tree.nodes["Refraction BSDF"].inputs[1],'default_value',text="Roughness")
            box.prop(bpy.data.materials["AQUA OCEAN"].node_tree.nodes["Refraction BSDF"].inputs[2],'default_value',text="IOR")
            box.label(text="Ocean Settings")
            box.prop(bpy.data.objects['Aqua Ocean'].modifiers["Ocean"], "repeat_x", text="repeat x")
            box.prop(bpy.data.objects['Aqua Ocean'].modifiers["Ocean"], "repeat_y", text="repeat y")
            box.prop(bpy.data.objects['Aqua Ocean'].modifiers["Ocean"], "size", text="Size")
            box.prop(bpy.data.objects['Aqua Ocean'].modifiers["Ocean"], "spatial_size", text="Spatial Size")
            box.prop(bpy.data.objects['Aqua Ocean'].modifiers["Ocean"], "wave_scale", text="Wave Scale")
            box.prop(bpy.data.objects['Aqua Ocean'].modifiers["Ocean"], "choppiness", text="Choppiness")
            box.prop(bpy.data.objects['Aqua Ocean'].modifiers["Ocean"], "wave_alignment", text="Wave Alignment")

            box = layout.box()
            box.label(text="Lighting", icon="LIGHT_HEMI")
            box.prop(bpy.data.objects['Aqua Sun'].data, "color", text="Sun Color")
            box.prop(bpy.data.objects['Aqua Sun'].data, "energy", text="Sun Energy")
            box.prop(bpy.data.worlds["AQUA WORLD"].node_tree.nodes["Background"].inputs[1], 'default_value', text="World Strength")
            box.prop(bpy.data.lights["Caustics Spot"].node_tree.nodes["Emission.001"].inputs[1], 'default_value', text="Caustics Strength")
            box.prop(bpy.data.objects["Ocean Rays"].data, 'color', text="Caustics Color")

            box = layout.box()
            box.label(text="Under Water Volume", icon="SHADING_RENDERED")
            box.prop(bpy.data.materials["AQUA VOLUME"].node_tree.nodes["Principled Volume"].inputs[0], 'default_value', text="Water Color")
            box.prop(bpy.data.materials["AQUA VOLUME"].node_tree.nodes["Principled Volume"].inputs[2], 'default_value', text="Density")
            box.prop(bpy.data.materials["AQUA VOLUME"].node_tree.nodes["Principled Volume"].inputs[4], 'default_value', text="Anisotrophy")
            
            box = layout.box()
            box.label(text="Water Particles", icon="POINTCLOUD_DATA")
            box.prop(bpy.data.particles["ParticleSettings"], "count", text="Count")
            box.prop(bpy.data.particles["ParticleSettings"], "particle_size", text="Particle Size")
            box.prop(bpy.data.particles["ParticleSettings"], "normal_factor", text="Velocity")


        else:
            box = layout.box()
            box.label(text="No Aqua Setup Found")

  
class OBJECT_PT_aquainfo(Panel):
    bl_label = "Help"
    bl_idname = "OBJECT_PT_aqua_info"
    bl_space_type = "VIEW_3D"   
    bl_region_type = "UI"    
    bl_category = "Aqua"
    bl_context = "objectmode"  

    def draw(self, context):
        layout = self.layout
        wm = context.window_manager
        scene = context.scene
        cscene = scene.cycles
        obj = bpy.context.active_object



preview_collections = {}
icon_collection = {}


def register():
	
    from bpy.types import WindowManager
    from bpy.props import (
            StringProperty,
            EnumProperty,
            )

    WindowManager.sh_previews_dire = StringProperty(
            name="Folder Path",
            subtype='DIR_PATH',
            default=""
            )

    WindowManager.sh_previewse = EnumProperty(
            items=enum_previews_from_directory_itemsj,
            )

    WindowManager.sh_previews_direa = StringProperty(
            name="Folder Path",
            subtype='DIR_PATH',
            default=""
            )

    WindowManager.sh_previewsea = EnumProperty(
            items=enum_previews_from_directory_itemsa,
            )

    WindowManager.sh_previews_di = StringProperty(
            name="Folder Path",
            subtype='DIR_PATH',
            default=""
            )

    WindowManager.sh_previe = EnumProperty(
            items=enum_previews_from_directory_ite,
            )

    import bpy.utils.previews
    aqualle = bpy.utils.previews.new()
    aqualle.sh_previews_dire = ""
    aqualle.sh_previewse = ()

    aquallea = bpy.utils.previews.new()
    aquallea.sh_previews_direa = ""
    aquallea.sh_previewsea = ()

    aqual = bpy.utils.previews.new()
    aqual.sh_previews_di = ""
    aqual.sh_previe = ()

    vconz = bpy.utils.previews.new()
    my_icons_dir = os.path.join(os.path.dirname(__file__), "icons")
    vconz.load("youtube", os.path.join(my_icons_dir, "Youtube.png"), 'IMAGE')
    vconz.load("discord", os.path.join(my_icons_dir, "Discord.png"), 'IMAGE')
    icon_collection["icons"] = vconz

    preview_collections["maaine"] = aqualle
    preview_collections["maainea"] = aquallea
    preview_collections["maine"] = aqual
 
    bpy.utils.register_class(OBJECT_PT_aquaPanel)
    # bpy.utils.register_class(OBJECT_PT_aquainfo)
    bpy.utils.register_class(WM_OT_infosst)
    bpy.utils.register_class(WM_OT_aquacombo)
    bpy.utils.register_class(WM_OT_infoist)
    bpy.utils.register_class(WM_OT_aquareveal)
    bpy.utils.register_class(WM_OT_aquaasset)


def unregister():
    from bpy.types import WindowManager

    del WindowManager.sh_previewse

    for aqualle in preview_collections.values():
        bpy.utils.previews.remove(aqualle)

    for vconz in icon_collection.values():
        bpy.utils.previews.remove(vconz)
    icon_collection.clear()
    preview_collections.clear()

    bpy.utils.unregister_class(OBJECT_PT_aquaPanel)
    # bpy.utils.unregister_class(OBJECT_PT_aquainfo)
    bpy.utils.unregister_class(WM_OT_infosst)
    bpy.utils.unregister_class(WM_OT_infoist)
    bpy.utils.unregister_class(WM_OT_aquacombo)
    bpy.utils.unregister_class(WM_OT_aquareveal)
    bpy.utils.unregister_class(WM_OT_aquaasset)


if __name__ == "__main__":
    register()
